package com.relovate.tripVerticles.verticles;

import io.vertx.core.AbstractVerticle;
import io.vertx.core.eventbus.EventBus;
import io.vertx.core.eventbus.MessageConsumer;
import io.vertx.core.json.JsonObject;

public class CommVerticle  extends AbstractVerticle{
	public void start() {	
		JsonObject req = config();//get configuration
		String tripId=req.getString("tripId");		 
		EventBus eb = vertx.eventBus();
	       MessageConsumer<String> consumer = eb.consumer(tripId);
	        consumer.handler(message -> {
	          System.out.println("I have received a message: " + message.body());
	          message.reply("how interesting!");
	        });
	        consumer.completionHandler(res -> {
	        	  if (res.succeeded()) {
	        	    System.out.println("The handler registration of CommVerticle has reached all nodes");
	        	  } else {
	        	    System.out.println("Registration failed!");
	        	  }
	        	});
	  }	
	@Override
    public void stop() throws Exception {
		 System.out.println("CommVerticle stopped!");
    }
}
