package com.relovate.tripVerticles.verticles;

import io.vertx.core.AbstractVerticle;
import io.vertx.core.eventbus.EventBus;
import io.vertx.core.eventbus.MessageConsumer;
import io.vertx.core.json.JsonObject;

public class TripVerticle extends AbstractVerticle{
	private JsonObject tripObject=new JsonObject();
	public void start() {	
		JsonObject req = config();//get configuration
		String tripId=req.getString("tripId");	
		String tripString=req.getString(tripId);		
		tripObject=new JsonObject();
		tripObject.put(tripId, tripString);
		EventBus  eb= vertx.eventBus();
	       MessageConsumer<String> consumer = eb.consumer(tripId);
	        consumer.handler(message -> {
	        	//System.out.println("Trip="+tripObject.getJsonObject(tripId));
	        	//System.out.println(tripString);
	        	/*JSONObject updateTrip=getUpdatedTrip(new JSONObject(message.body()), tripObject.getJSONObject(tripId));
	        	System.out.println(updateTrip);*/	
	        	JsonObject requestJson=new JsonObject(message.body());	        	  
	        	try {
	        		JsonObject resObject=new JsonObject();
	        		resObject.put("response", "dummy");
	        		message.reply(resObject.toString());	
	        	} catch (Exception e) {	
					System.out.println("Exception in tripverticle "+e.getMessage());
					e.printStackTrace();
					JsonObject exceptionMsgObj=new JsonObject();
					exceptionMsgObj.put("errorCode", "CTEX01");
					message.reply(exceptionMsgObj.toString());
				}	
	        	/*vertx.executeBlocking(future -> {
	        		  // Call some blocking API that takes a significant amount of time to return
	        		JsonObject trip=new JsonObject(tripObject.getString(tripId));
	        		JsonObject jsonRequest=new JsonObject(message.body());
	        		JsonObject requestObject = jsonRequest
	        				.getJsonObject("UpdateTripAttribute");	
	        		String attributeName="";
	        		Object attibuteValue="";
	        		if(requestObject.containsKey(EnhanceTripConstant.TRIP_NAME))
	        		{
	        			attributeName=EnhanceTripConstant.TRIP_NAME;
	        			attibuteValue=requestObject.getString(EnhanceTripConstant.TRIP_NAME);		
	        		}
	        		trip.put(attributeName, attibuteValue);
	        		trip.put(EnhanceTripConstant.ISUSED, true);
	        		  future.complete(trip);
	        		}, res -> {
	        			message.reply(res.result().toString());
	        		  System.out.println("The result is: " + res.result());
	        		});*/
	        	/*eb.send(
	        	        "update.req",
	        	        message.body()
	        	    );*/
	        	/*getUpdatedTrip(new JsonObject(tripObject.getString(tripId)), new JsonObject(message.body())).setHandler(
	        	        new Handler<AsyncResult<JsonObject>>() {
	        	           							@Override
							public void handle(AsyncResult<JsonObject> result) {
	        	           							 message.reply(result.result().toString());
	        	           							 tripObject.put(tripId, result.result().toString());
								
							}
	        	        }
	        	      );*/
	        	/*JsonObject trip=new JsonObject(tripObject.getString(tripId));	        	
	        	//System.out.println(trip);
	        	JSONObject requestObject=new JSONObject(message.body()).getJSONObject("UpdateTripAttribute");
	        	//System.out.println(requestObject.getString("tripName"));
	        	trip.put("tripName", requestObject.getString("tripName"));
        		//trip.put(EnhanceTripConstant.ISUSED, true);		            		  
	        		  message.reply(trip.toString());
	        		  tripObject.put(tripId, trip.toString());*/
	        });
	        consumer.completionHandler(res -> {
	        	  if (res.succeeded()) {
	        	    System.out.println("The handler registration of TripVerticle has reached all nodes");
	        	  } else {
	        	    System.out.println("Registration failed!");
	        	  }
	        	});
	  }	
	@Override
    public void stop() throws Exception {
		 System.out.println("TripVerticle stopped!");
    }
	
/*private Future<JsonObject> getUpdatedTrip(JsonObject trip,JsonObject jsonRequest)
{	
	 Future<JsonObject> f = Future.future();
	 JsonObject requestObject = jsonRequest
			.getJsonObject("UpdateTripAttribute");	
	String attributeName="";
	Object attibuteValue="";
	if(requestObject.containsKey(EnhanceTripConstant.TRIP_NAME))
	{
		attributeName=EnhanceTripConstant.TRIP_NAME;
		attibuteValue=requestObject.getString(EnhanceTripConstant.TRIP_NAME);		
	}
	trip.put(attributeName, attibuteValue);
	trip.put(EnhanceTripConstant.ISUSED, true);
	 f.complete(trip);
	    return f;
}*/
}
